package MT::Plugin::SKR::BasicAuthAutoCompleteLogin;

use strict;
use MT::Util qw( encode_html );
use MIME::Base64;

use vars qw( $MYNAME $VERSION );
$MYNAME = 'BasicAuthAutoCompleteLogin';
$VERSION = '0.02';

use base qw( MT::Plugin );
my $plugin = __PACKAGE__->new({
    name => $MYNAME,
    id => lc $MYNAME,
    key => lc $MYNAME,
    version => $VERSION,
    author_name => 'SKYARC System Co.,Ltd.',
    author_link => 'http://www.skyarc.co.jp/',
    description => <<PERLHEREDOC,
<__trans phrase="Set username and password automatically in MT login with Basic authentication's input">
PERLHEREDOC
#    l10n_class => $MYNAME. '::L10N',
});
MT->add_plugin ($plugin);

sub instance { $plugin; }



sub init_registry {
    my $plugin = shift;
    $plugin->registry({
        callbacks => {
            'MT::App::CMS::template_source.login_mt' => \&_edit_entry_source,
        },
    });
}

###
sub _edit_entry_source {
    my ($eh, $app, $tmpl) = @_;

    my $env = $ENV{HTTP_AUTHORIZATION}
        or return;
    my ($auth_token) = $env =~ /\w+\s+(\w+)/;

    my $pass_token = decode_base64 ($auth_token);
    my ($username, $password) = $pass_token =~ /^([^:]+):(.+)/;

    $username = encode_html ($username);
    $$tmpl =~ s/(name="username")/$1 value="$username" readonly="readonly"/;
    $password = encode_html ($password);
    $$tmpl =~ s/(name="password")/$1 value="$password" readonly="readonly"/;
}

1;
__END__
RewriteEngine On
RewriteCond %{HTTP:AUTHORIZATION} (.*)
RewriteRule .* - [E=HTTP_AUTHORIZATION:%1]
